//--------------------------------
//--------------------------------
//---------- Block Cam -----------
//--------------------------------
//- 1. Author: Elm (35925) -------
//- 2. Version: "1.2" ------------
//- 3. Version Type: PRE - BETA --
//- 4. Format: Header > Package > 
//-    Functions > Gui Elements > 
//-    Gui Functions -------------
//--------------------------------
//--------------------------------
//--------------------------------
//--------------------------------

//*PACKAGE*

package BlockCam
{	
	function loadingGui::onWake(%OBJ_GUI)
	{
		%DATA_P = parent::onWake(%OBJ_GUI);

		if(bc_loadingGuiWatermark.initialized $= "")
		{
			bc_initWatermark();
		}
		
		if($PREF::BC::LOADINGGUICUSTOMIMAGE)
		{
			bc_loadingGuiWatermark.setVisible(1);
			bc_loadingGuiImageCycle();
		}
		
		return %DATA_P;
	}
	
	function loadingGui::onSleep(%OBJ_GUI)
	{
		%DATA_P = parent::onSleep(%OBJ_GUI);
		 
		if($PREF::BC::LOADINGGUICUSTOMIMAGE)
		{
			cancel($BC::LOADINGGUIIMAGECYCLELOOP);
			bc_loadingGuiWatermark.setVisible(0);
		}
		
		Load_mapPicture.setBitmap($BC::LOADINGGUIDEFAULTIMAGE);
		
		return %DATA_P;	
	}
	
	function doDofScreenShot(%INT_VAL)
	{
		bc_UICornerSwatch.setVisible(0);
		bc_UISSTypeSwatch.setVisible(0);
		bc_UINewPicture.setVisible(0);
		
		parent::doDofScreenShot(%INT_VAL);
		
		if($BC::CAMMODE && %INT_VAL)
		{
			bc_screenShotOnDone();
		}
	}
	
	function doScreenShot(%INT_VAL)
	{
		bc_UICornerSwatch.setVisible(0);
		bc_UISSTypeSwatch.setVisible(0);
		bc_UINewPicture.setVisible(0);
	
		parent::doScreenShot(%INT_VAL);
		
		if($BC::CAMMODE && %INT_VAL)
		{
			bc_screenShotOnDone();
		}
	}
	
	function doHUDScreenShot(%INT_VAL)
	{
		bc_UICornerSwatch.setVisible(0);
		bc_UISSTypeSwatch.setVisible(0);
		bc_UINewPicture.setVisible(0);
		bc_exitCamMode();
		
		$BC::CAMMODE = TRUE;
	
		parent::doHUDScreenShot(%INT_VAL);
		
		if($BC::CAMMODE && %INT_VAL)
		{
			bc_enterCamMode();
			bc_screenShotOnDone();
		}
	}
	
	function doIconScreenShot(%INT_VAL)
	{
		bc_UICornerSwatch.setVisible(0);
		bc_UISSTypeSwatch.setVisible(0);
		bc_UINewPicture.setVisible(0);
		
		parent::doIconScreenShot(%INT_VAL);
		
		if($BC::CAMMODE && %INT_VAL)
		{
			bc_screenShotOnDone();
		}
	}
	
	function doPanoramaScreenShot(%INT_VAL)
	{
		bc_UICornerSwatch.setVisible(0);
		bc_UISSTypeSwatch.setVisible(0);
		bc_UINewPicture.setVisible(0);
		
		parent::doPanoramaScreenShot(%INT_VAL);
		
		if($BC::CAMMODE && %INT_VAL)
		{
			bc_screenShotOnDone();
		}
	}
	
	function disconnectedCleanup(%INT_VAL)
	{
		if($BC::CAMMODE)
			bc_exitCamMode();
			
		return parent::disconnectedCleanup(%INT_VAL);
	}
	
	function optionsDlg::onSleep(%OBJ_CTRL)
	{
		if(!$BC::CAMMODE)
		{
			$BC::SPACECOMMAND = moveMap.getCommand("keyboard","space");
			$BC::LEFTMOUSECOMMAND = moveMap.getCommand("mouse0","button0");
			$BC::RIGHTMOUSECOMMAND = moveMap.getCommand("mouse0","button1");
			$BC::LEFTARROWKEYCOMMAND = moveMap.getCommand("keyboard","left");
			$BC::RIGHTARROWKEYCOMMAND = moveMap.getCommand("keyBoard","right");
		}
		return parent::onSleep(%OBJ_CTRL);
	}
	
	function onExit(%NULL1,%NULL2,%NULL3)
	{
		if($BC::CAMMODE)
		{
			bc_exitCamMode();
		}
		
		parent::onExit(%NULL1,%NULL2,%NULL3);
	}
};

if(!$BC::BIND)
{
	$remapDivision[$remapCount] = "Block Cam";
	$remapName[$remapCount] = "Enter/Exit Cam Mode";
	$remapCmd[$remapCount] = "BC_ToggleCamMode";
	$remapCount++;
	$BC::BIND = true;
}

//*FUNCTIONS*

function bc_initialize()
{
	activatePackage(BlockCam);

	//VARIABLE INITIALIZATION
	$BC::VERSION = "1.2";
	$BC::USERNAME = $PREF::PLAYER::NETNAME;
	$BC::TEMPSHADEMODE = false;
	$BC::FOV = $PREF::PLAYER::DEFAULTFOV;
	$BC::FOVSET = 0;
	$BC::LOADINGGUIDEFAULTIMAGE = load_mapPicture.bitmap;
	$BC::SPACECOMMAND = moveMap.getCommand("keyboard","space");
	$BC::LEFTMOUSECOMMAND = moveMap.getCommand("mouse0","button0");
	$BC::RIGHTMOUSECOMMAND = moveMap.getCommand("mouse0","button1");
	$BC::LEFTARROWKEYCOMMAND = moveMap.getCommand("keyboard","left");
	$BC::RIGHTARROWKEYCOMMAND = moveMap.getCommand("keyBoard","right");
	$BC::SHADENAME[0] = "Off";
	$BC::SHADENAME[1] = "Minimum";
	$BC::SHADENAME[2] = "Low";
	$BC::SHADENAME[3] = "Medium";
	$BC::SHADENAME[4] = "High";
	$BC::SHADENAME[5] = "Very High";
	$BC::SHADENAME[6] = "Max";
	
	//HAS THE USER RAN BLOCKCAM BEFORE? IF NOT..
	if(!$PREF::BC::INITIALSETUP)
	{
		$PREF::BC::INITIALSETUP = true;
		$PREF::BC::DEBUG = true;
		$PREF::BC::BLOCKCAMSHADEQUALITY = 3;
		$PREF::BC::BLOCKCAMSHOTTYPE = "DEFAULT";
		$PREF::BC::HIDEDEFAULTSCREENSHOTS = 0;
		$PREF::BC::LOADINGGUICUSTOMIMAGE = 1;
		$PREF::BC::LOADINGGUICYCLETIME = 10000;
		
		bc_log("Thank you for using Block Cam V " @ $BC::VERSION @ "," @ $BC::USERNAME @ ".");		
	}
	
	schedule(100,0,bc_screenShotsToContainer);	
	//bc_initWaterMark();
	
	bc_log("Running Block Cam " @ $BC::VERSION); 
}

function bc_log(%STR)
{
	if($PREF::BC::DEBUG)
		echo("\c4BLOCK CAM " @ $BC::VERSION @ " : " @ %STR);
}

function bc_setSHADELevel(%INT_QUALITY)
{
	optionsDlg.setSHADErQuality(%INT_QUALITY);
	
	bc_log("Changed SHADE quality to " @ $BC::SHADENAME[%INT_QUALITY] @ ".");
}

function bc_setBlockCamShadeQuality(%INT_QUALITY)
{
	$PREF::BC::BLOCKCAMSHADEQUALITY = %INT_QUALITY;
	
	%OBJ_RADIOCTRL = bc_blockCamShadeQuality @ %INT_QUALITY;
	%OBJ_RADIOCTRL.setValue(true);
}

function bc_getSHADELevel()
{
	for(%i=0;%i<7;%i++)
	{
		%GUI_ELEMENT = OPT_shaderQuality @ %i;
		if(%GUI_ELEMENT.getValue() $= "1")
		{
			%INT_SHADELEVEL = %i;
			break;
		}
	}
	
	if(!%INT_SHADELEVEL)
		return 0;
	
	bc_log("Running " @ $BC::SHADENAME[%i] @ " Shaders.");
	return %INT_SHADELEVEL;
}

function bc_takeScreenShot(%STR_TYPE)
{
	if(!$BC::CAMMODE) return 0;
	
	if(%STR_TYPE $= "DEFAULT")
	{
		bc_setTempSHADEMode($PREF::BC::BLOCKCAMSHADEQUALITY);
		doScreenShot(1);
	}
	else
	if(%STR_TYPE $= "DOF")
	{
		bc_setTempSHADEMode($PREF::BC::BLOCKCAMSHADEQUALITY);
		doDofScreenShot(1);	
	}
	else
	if(%STR_TYPE $= "HUD")
	{
		bc_setTempSHADEMode($PREF::BC::BLOCKCAMSHADEQUALITY);
		doHudScreenShot(1);
	}
	else
	if(%STR_TYPE $= "ICON")
	{
		bc_setTempSHADEMode($PREF::BC::BLOCKCAMSHADEQUALITY);
		doIconScreenShot(1);
	}
	if(%STR_TYPE $= "PANORAMA")
	{
		bc_setTempSHADEMode($PREF::BC::BLOCKCAMSHADEQUALITY);
		doPanoramaScreenShot(1);
	}
	
	bc_log("Took a " @ %STR_TYPE @ " screen shot");
}

function bc_screenShotOnDone()
{
	if($BC::FLAGASTEMPMODE)
	{
		$BC::FLAGASTEMPMODE = false;
		bc_setSHADELevel($BC::USERSHADEQUALITY);
		bc_UICornerSwatch.setVisible(1);
		bc_UISSTypeSwatch.setVisible(1);

		%STR_IMAGEPATH = bc_getNewestScreenShot();
		
		if(%STR_IMAGEPATH !$= "0")
		{
			bc_UICornerImage.setBitmap(%STR_IMAGEPATH);
		}
		
		bc_screenShotsToContainer();
		bc_UINewPicture.setVisible(1);
		cancel(bc_UINewPicture.event);
		bc_UINewPicture.event = bc_UINewPicture.schedule(3000,setvisible,0);
	}
}

function bc_getNewestScreenShot()
{
	//I wish there was a better method
	//--------------------------------
	setmodpaths(getmodpaths());
	//--------------------------------
	
	%INT_FILECOUNT = getFileCount("screenshots/*");
	
	for(%i=0;%i<%INT_FILECOUNT;%i++)
	{
		%STR_FILE = findNextFile("screenshots/*");
		
		if(bc_screenShotContainer.fileRegistered[%STR_FILE])
			continue;
		
		return %STR_FILE;
	}
	
	return false;
}

function bc_setTempSHADEMode(%INT_QUALITY)
{	
	$BC::USERSHADEQUALITY = bc_getSHADELevel();
	$BC::FLAGASTEMPMODE = true;
	
	bc_setSHADELevel(%INT_QUALITY);
}

function bc_ToggleCamMode(%INT_VAL)
{
	if(%INT_VAL)
	{
		if($BC::CAMMODE)
			bc_exitCamMode();
		else
			bc_enterCamMode();
	}
}

function bc_enterCamMode()
{
	if(playgui.isAwake() && isObject(serverConnection.getControlObject()))
	{
		canvas.setContent(noHudGui);
		
		%res = getWords(getRes(),0,1);
		
		noHUDGUI.add(bc_UICornerSwatch);
		noHUDGUI.add(bc_UISSTypeSwatch);
		noHUDGUI.add(bc_UINewPicture);
		
		bc_UICornerSwatch.position = 10 SPC getWord(%res,1) - 80;
		bc_UISSTypeSwatch.position = (getWord(bc_UICornerSwatch.position,0) + getWord(bc_UICornerSwatch.extent,0) + 10) SPC getWord(bc_UICornerSwatch.position,1);
		
		%INT_PICX = (getWord(bc_UICornerSwatch.position,0) + getWord(bc_UICornerSwatch.extent,0) / 2) - (bc_UINewPicture.extent / 2);
		%INT_PICY = (getWord(bc_UICornerSwatch.position,1) - getWord(bc_UICornerSwatch.extent,1) / 2);
		%INT_PICX = mfloor(%INT_PICX);
		%INT_PICY = mfloor(%INT_PICY);
		
		bc_UINewPicture.position = %INT_PICX SPC %INT_PICY;
		
		bc_UICornerSwatch.setVisible(1);
		bc_UISSTypeSwatch.setVisible(1);
		
		%GUI_RADIOCTRL = bc_shotType @ $PREF::BC::BLOCKCAMSHOTTYPE;
		%GUI_RADIOCTRL.setValue(1);
		
		$BC::CAMMODE = true;
		
		//Just incase..
		if($BC::SPACECOMMAND $= "" || $BC::LEFTMOUSECOMMAND $= "" || $BC::RIGHTMOUSECOMMAND $= "")
		{
			error("SOMETHING IS WRONG WITH TOGGLING INTO CAMERAMODE, ABORT");
			bc_exitCamMode();
		}
		else
		{
			moveMap.bind("keyboard","space",bc_spaceKeyDown);
			moveMap.bind("mouse0","button0",bc_leftMouseButtonDown);
			moveMap.bind("mouse0","button1",bc_rightMouseButtonDown);
		}
		
		bc_log("Entered camera mode.");
	}
}

function bc_exitCamMode()
{
	if(noHudGUI.isAwake())
	{
		canvas.setContent(playGUI);
		
		bc_UICornerSwatch.setVisible(0);
		bc_UISSTypeSwatch.setVisible(0);
		bc_UINewPicture.setVisible(0);
		
		noHudGui.remove(bc_UICornerSwatch);
		noHudGui.remove(bc_UISSTypeSwatch);
		noHudGui.remove(bc_UINewPicture);
		
		setFov($BC::FOV);
		
		$BC::CAMMODE = false;
		$BC::FOVSET = 0;
		$BC::FOVNUMBER = 0;
		
		moveMap.bind("keyboard","space",$BC::SPACECOMMAND);
		moveMap.bind("mouse0","button0",$BC::LEFTMOUSECOMMAND);
		moveMap.bind("mouse0","button1",$BC::RIGHTMOUSECOMMAND);
		
		bc_log("Returning to normal mode.");
	}
}

function bc_spaceKeyDown(%INT_VAL)
{
	if(%INT_VAL)
	{
		bc_takeScreenShot($PREF::BC::BLOCKCAMSHOTTYPE);
	}
}

function bc_leftMouseButtonDown(%INT_VAL)
{
	if($BC::CAMMODE)
	{
		if(%INT_VAL)
		{
			bc_zoomIn();
		}
		else
		{
			cancel($BC::ZOOMINLOOP);
		}
	}	
}

function bc_rightMouseButtonDown(%INT_VAL)
{
	if($BC::CAMMODE)
	{
		if(%INT_VAL)
		{
			bc_zoomOut();
		}
		else
		{
			cancel($BC::ZOOMOUTLOOP);
		}
	}
}

function bc_setScreenShotType(%STR_TYPE)
{	
	%OBJ_RADIOCTRL = bc_ShotType @ %STR_TYPE;
	
	if(isObject(%OBJ_RADIOCTRL))
	{
		bc_log("Changing screen shot type to " @ %STR_TYPE);
		$PREF::BC::BLOCKCAMSHOTTYPE = %STR_TYPE;
		%OBJ_RADIOCTRL.SETVALUE(1);
	}
}

//HACK - NOT CURRENTLY IN USE
function bc_checkForScreenShotCompletionHack()
{
	cancel($BC::CAMCHECKLOOP);
	
	if($BC::CAMCHECKTIME $= "")
	{
		%REALTIME = getRealTime();
		$BC::CAMCHECKTIME = %REALTIME;
		$BC::CHAMCHECKSTARTTIME = %REALTIME;
	}
	else
	{
		%REALTIME = getRealTime();
		if(%REALTIME - $BC::CAMCHECKTIME > 300)
		{
			$BC::CAMCHECKTIME = "";
			bc_log("Screenshot taken in " @ getRealTime() - $BC::CHAMCHECKSTARTTIME @ " milliseconds");
			bc_screenShotOnDone();
			return true;
		}
		
		$BC::CAMCHECKTIME = getRealTime();
	}
	
	$BC::CAMCHECKLOOP = schedule(1,0,bc_checkForScreenShotCompletionHack);
}

//HACK
function bc_newFolder(%STR_PATH)
{
	if(fileEXT(%STR_PATH) !$= "")
	{
		bc_log("\c4Error: please remove any extentions when trying to create a folder.");
		return 0;
	}
	
	%STR_BASE = fileBase(%STR_PATH);
	%STR_BASE = strUpr(getSubstr(%STR_BASE,0,1)) @ getSubStr(%STR_BASE,1,strLen(%STR_BASE));
	%STR_PATH = filePath(%STR_PATH) @ "/" @ %STR_BASE;
	
	%OBJ_FILEOBJ = new fileObject();
	%OBJ_FILEOBJ.openForWrite(%STR_PATH @ "/TEMP.TXT");
	%OBJ_FILEOBJ.close();
	%OBJ_FILEOBJ.delete();
	
	fileDelete(%STR_PATH @ "/TEMP.TXT");
	
	return 1;
}

function bc_zoomIn()
{
	cancel($BC::ZOOMINLOOP);
	
	if($BC::FOVSET == 0)
	{
		$BC::FOVSET = true;
		$BC::CURRENTFOV = $BC::FOV;
		$BC::FOVNUMBER = 0;
	}
	
	$BC::FOVNUMBER--;
	%INT_FOV_TOTAL = $BC::CURRENTFOV + $BC::FOVNUMBER;
	setFov(%INT_FOV_TOTAL);
	
	$BC::ZOOMINLOOP = schedule(10,0,bc_zoomIn);
}

function bc_zoomOut()
{
	cancel($BC::ZOOMOUTLOOP);
	
	if($BC::FOVSET == 0)
	{
		$BC::FOVSET = true;
		$BC::CURRENTFOV = $BC::FOV;
		$BC::FOVNUMBER = 0;
	}
	
	$BC::FOVNUMBER++;
	%INT_FOV_TOTAL = $BC::CURRENTFOV + $BC::FOVNUMBER;
	setFov(%INT_FOV_TOTAL);
	
	$BC::ZOOMOUTLOOP = schedule(10,0,bc_zoomOut);
}

function bc_loadingGuiImageCycle()
{
	cancel($BC::LOADINGGUIIMAGECYCLELOOP);
	
	%OBJ_IMAGEDATA = bc_screenShotContainer.getObject(getRandom(0,bc_screenShotContainer.getCount()-1));
	
	//Just incase..
	if(isObject(%OBJ_IMAGEDATA))
	{
		load_mapPicture.setBitmap(%OBJ_IMAGEDATA.path);
	}
	
	$BC::LOADINGGUIIMAGECYCLELOOP = schedule($PREF::BC::LOADINGGUICYCLETIME,0,bc_loadingGuiImageCycle);
}

//*GUI*

if(isObject(bc_control))
	bc_control.delete();
if(isObject(bc_UICornerSwatch))
	bc_UICornerSwatch.delete();
if(isObject(bc_UISSTypeSwatch))
	bc_UISSTypeSwatch.delete();
if(isObject(bc_loadingGuiWaterMark))
	bc_loadingGuiWaterMark.delete();
if(isObject(bc_UINewPicture))
	bc_UINewPicture.delete();
if(isObject(bc_renameSS))
	bc_renameSS.delete();
	
//--- OBJECT WRITE BEGIN ---
new GuiControl(bc_control) {
   profile = "GuiDefaultProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "0 0";
   extent = "800 600";
   minExtent = "8 8";
   enabled = "1";
   visible = "1";
   clipToParent = "1";

   new GuiWindowCtrl() {
      profile = "BlockWindowProfile";
      horizSizing = "center";
      vertSizing = "center";
      position = "96 49";
      extent = "607 501";
      minExtent = "8 8";
      enabled = "1";
      visible = "1";
      clipToParent = "1";
      maxLength = "255";
      resizeWidth = "0";
      resizeHeight = "0";
      canMove = "1";
      canClose = "1";
      canMinimize = "0";
      canMaximize = "0";
      minSize = "50 50";
	  command = "canvas.popdialog(bc_control);";
	  accelerator = "escape";
      closeCommand = "Canvas.popDialog(bc_control);";

      new GuiSwatchCtrl(bc_ssSingleSwatch) {
         profile = "GuiDefaultProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "-2 14";
         extent = "607 500";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         color = "0 118 80 2";

         new GuiSwatchCtrl() {
            profile = "GuiDefaultProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "6 10";
            extent = "600 474";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            color = "100 100 100 200";

            new GuiSwatchCtrl() {
               profile = "GuiDefaultProfile";
               horizSizing = "right";
               vertSizing = "bottom";
               position = "5 357";
               extent = "589 110";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               color = "200 200 200 200";
            };
            new GuiSwatchCtrl() {
               profile = "GuiDefaultProfile";
               horizSizing = "right";
               vertSizing = "bottom";
               position = "6 7";
               extent = "587 312";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               color = "200 200 200 200";
            };
            new GuiBitmapCtrl(bc_screenShotView) {
               profile = "GuiDefaultProfile";
               horizSizing = "right";
               vertSizing = "bottom";
               position = "11 13";
               extent = "576 300";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               bitmap = "screenshots/acmcity";
			   wrap = "0";
			   lockAspectRatio = "0";
			   alignLeft = "0";
			   overflowImage = "0";
			   keepCached = "0";
            };
            new GuiBitmapButtonCtrl() {
               profile = "GuiDefaultProfile";
               horizSizing = "right";
               vertSizing = "bottom";
               position = "233 325";
               extent = "38 30";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               text = "   ";
               groupNum = "-1";
               buttonType = "PushButton";
               bitmap = "add-ons/client_blockcam/images/previous_icon";
			   command = "bc_GUIPreviousScreenShot();";
               lockAspectRatio = "0";
               alignLeft = "0";
               alignTop = "0";
               overflowImage = "0";
               mKeepCached = "0";
               mColor = "255 255 255 255";
            };
            new GuiBitmapButtonCtrl() {
               profile = "GuiDefaultProfile";
               horizSizing = "right";
               vertSizing = "bottom";
               position = "324 325";
               extent = "38 30";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               text = "   ";
               groupNum = "-1";
               buttonType = "PushButton";
               bitmap = "add-ons/client_blockcam/images/next_icon";
			   command = "bc_GUINextScreenShot();";
               lockAspectRatio = "0";
               alignLeft = "0";
               alignTop = "0";
               overflowImage = "0";
               mKeepCached = "0";
               mColor = "255 255 255 255";
            };
            new GuiBitmapButtonCtrl() {
               profile = "GuiDefaultProfile";
               horizSizing = "right";
               vertSizing = "bottom";
               position = "557 323";
               extent = "31 30";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               text = "   ";
               groupNum = "-1";
               buttonType = "PushButton";
               bitmap = "add-ons/client_blockcam/images/fullscreen_icon";
               lockAspectRatio = "0";
               alignLeft = "0";
               alignTop = "0";
               overflowImage = "0";
               mKeepCached = "0";
               mColor = "255 255 255 255";
			   command = "bc_guiFullScreenBitmap();";
            };
            new GuiBitmapButtonCtrl() {
               profile = "GuiDefaultProfile";
               horizSizing = "right";
               vertSizing = "bottom";
               position = "527 323";
               extent = "31 30";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               text = "   ";
               groupNum = "-1";
               buttonType = "PushButton";
               bitmap = "add-ons/client_blockcam/images/delete_icon";
               lockAspectRatio = "0";
               alignLeft = "0";
               alignTop = "0";
               overflowImage = "0";
               mKeepCached = "0";
               mColor = "255 255 255 255";
			   command = "bc_deleteScreenShot(bc_screenShotView.bitmap);";
            };
            new GuiBitmapButtonCtrl() {
               profile = "GuiDefaultProfile";
               horizSizing = "right";
               vertSizing = "bottom";
               position = "497 323";
               extent = "31 30";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               text = "   ";
               groupNum = "-1";
               buttonType = "PushButton";
               bitmap = "add-ons/client_blockcam/images/settings_icon";
               lockAspectRatio = "0";
               alignLeft = "0";
               alignTop = "0";
               overflowImage = "0";
               mKeepCached = "0";
               mColor = "255 255 255 255";
			   command = "bc_ssSingleSwatch.setVisible(0);bc_optionsSwatch.setVisible(1);";
            };
            new GuiScrollCtrl() {
               profile = "GuiScrollProfile";
               horizSizing = "right";
               vertSizing = "bottom";
               position = "11 364";
               extent = "577 97";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               willFirstRespond = "0";
               hScrollBar = "alwaysOn";
               vScrollBar = "alwaysOn";
               constantThumbHeight = "0";
               childMargin = "0 0";
               rowHeight = "40";
               columnWidth = "30";
			
               new GuiTextListCtrl(bc_sslist) {
                  profile = "GuiTextListProfile";
                  horizSizing = "right";
                  vertSizing = "bottom";
                  position = "1 1";
                  extent = "560 2";
                  minExtent = "8 2";
                  enabled = "1";
                  visible = "1";
                  clipToParent = "1";
                  enumerate = "0";
                  resizeCell = "1";
                  columns = "0";
                  fitParentWidth = "1";
                  clipColumnText = "0";
               };
            };
         };
      };
      new GuiSwatchCtrl(bc_optionsSwatch) {
         profile = "GuiDefaultProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "9 22";
         extent = "598 474";
         minExtent = "8 2";
         enabled = "1";
         visible = "0";
         clipToParent = "1";
         color = "0 118 80 2";

         new GuiSwatchCtrl() {
            profile = "GuiDefaultProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "5 10";
            extent = "581 39";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            color = "100 100 100 200";

            new GuiMLTextCtrl() {
               profile = "HUDChatTextEditSize4Profile";
               horizSizing = "center";
               vertSizing = "top";
               position = "2 5";
               extent = "577 29";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               lineSpacing = "2";
               allowColorChars = "0";
               maxChars = "-1";
               text = "<just:center><font:impact:30>Block Cam Options";
               maxBitmapHeight = "-1";
               selectable = "1";
               autoResize = "1";
            };
         };
         new GuiSwatchCtrl() {
            profile = "GuiDefaultProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "5 60";
            extent = "262 39";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            color = "100 100 100 200";

            new GuiMLTextCtrl() {
               profile = "HUDChatTextEditSize4Profile";
               horizSizing = "center";
               vertSizing = "top";
               position = "4 5";
               extent = "254 25";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               lineSpacing = "2";
               allowColorChars = "0";
               maxChars = "-1";
               text = "<just:center><font:impact:25>Screen Shot Quality";
               maxBitmapHeight = "-1";
               selectable = "1";
               autoResize = "1";
            };
         };
         new GuiRadioCtrl(bc_blockCamShadeQuality6) {
            profile = "GuiRadioProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "4 102";
            extent = "44 30";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            text = "Max";
            groupNum = "1";
            buttonType = "RadioButton";
			command = "bc_setBlockCamshadeQuality(6);";
         };
         new GuiRadioCtrl(bc_blockCamShadeQuality5) {
            profile = "GuiRadioProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "4 128";
            extent = "70 30";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            text = "Very High";
            groupNum = "1";
            buttonType = "RadioButton";
			command = "bc_setBlockCamshadeQuality(5);";
         };
         new GuiRadioCtrl(bc_blockCamShadeQuality4) {
            profile = "GuiRadioProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "4 153";
            extent = "50 30";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            text = "High";
            groupNum = "1";
            buttonType = "RadioButton";
			command = "bc_setBlockCamshadeQuality(4);";
         };
         new GuiRadioCtrl(bc_blockCamShadeQuality3) {
            profile = "GuiRadioProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "98 102";
            extent = "69 30";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            text = "Medium";
            groupNum = "1";
            buttonType = "RadioButton";
			command = "bc_setBlockCamshadeQuality(3);";
         };
         new GuiRadioCtrl(bc_blockCamShadeQuality2) {
            profile = "GuiRadioProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "98 128";
            extent = "56 30";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            text = "Low";
            groupNum = "1";
            buttonType = "RadioButton";
			command = "bc_setBlockCamshadeQuality(2);";
         };
         new GuiRadioCtrl(bc_blockCamShadeQuality1) {
            profile = "GuiRadioProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "98 153";
            extent = "66 30";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            text = "Minimum";
            groupNum = "1";
            buttonType = "RadioButton";
			command = "bc_setBlockCamshadeQuality(1);";
         };
         new GuiRadioCtrl(bc_blockCamShadeQuality0) {
            profile = "GuiRadioProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "179 102";
            extent = "86 30";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            text = "Off";
            groupNum = "1";
            buttonType = "RadioButton";
			command = "bc_setBlockCamshadeQuality(0);";
         };
         new GuiSwatchCtrl() {
            profile = "GuiDefaultProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "325 60";
            extent = "262 39";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            color = "100 100 100 200";

            new GuiMLTextCtrl() {
               profile = "HUDChatTextEditSize4Profile";
               horizSizing = "center";
               vertSizing = "top";
               position = "4 5";
               extent = "254 25";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               lineSpacing = "2";
               allowColorChars = "0";
               maxChars = "-1";
               text = "<just:center><font:impact:25>Save Path";
               maxBitmapHeight = "-1";
               selectable = "1";
               autoResize = "1";
            };
         };
         new GuiCheckBoxCtrl(bc_checkBox_savePath) {
            profile = "GuiCheckBoxProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "325 106";
            extent = "74 30";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            command = "bc_updateSavePath();";
            text = "Use Default";
            groupNum = "-1";
            buttonType = "ToggleButton";
         };
         new GuiTextEditCtrl(bc_textEdit_path) {
            profile = "GuiTextEditProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "402 111";
            extent = "185 18";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            maxLength = "255";
            historySize = "0";
            password = "0";
            tabComplete = "0";
            sinkAllKeyEvents = "0";
         };
         new GuiSwatchCtrl() {
            profile = "GuiDefaultProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "5 190";
            extent = "262 39";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            color = "100 100 100 200";

            new GuiMLTextCtrl() {
               profile = "HUDChatTextEditSize4Profile";
               horizSizing = "center";
               vertSizing = "top";
               position = "4 5";
               extent = "254 25";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               lineSpacing = "2";
               allowColorChars = "0";
               maxChars = "-1";
               text = "<just:center><font:impact:25>Default Screen Shots";
               maxBitmapHeight = "-1";
               selectable = "1";
               autoResize = "1";
            };
         };
		 new guiCheckBoxCtrl(bc_hideDefaultScreenShotCheckBox)
		 {
			profile = "GuiCheckBoxProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 230";
			extent = "140 30";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			text = "Hide Default Screenshots";
			command = "bc_toggleDefaultScreenShotVal();";
			buttonType = "toggleButton";
		 };
		 new guiButtonCtrl()
		 {
			profile = "guiButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 435";
			extent = "100 30";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			text = "Back";
			command = "bc_optionsSwatch.setVisible(0);bc_ssSingleSwatch.setVisible(1);";
			buttonType = "pushButton";
		 };
		 
         new GuiSwatchCtrl() {
            profile = "GuiDefaultProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "325 190";
            extent = "262 39";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            color = "100 100 100 200";

            new GuiMLTextCtrl() {
               profile = "HUDChatTextEditSize4Profile";
               horizSizing = "center";
               vertSizing = "top";
               position = "4 5";
               extent = "254 25";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               lineSpacing = "2";
               allowColorChars = "0";
               maxChars = "-1";
               text = "<just:center><font:impact:25>Loading Gui";
               maxBitmapHeight = "-1";
               selectable = "1";
               autoResize = "1";
            };
         };
		 new guiCheckBoxCtrl(bc_loadingGuiCheckBox)
		 {
			profile = "GuiCheckBoxProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "325 230";
			extent = "240 30";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			text = "Cycle Loading Screen Images";
			variable = "$PREF::BC::LOADINGGUICUSTOMIMAGE";
			buttonType = "toggleButton";
		 };
		 new GuiSliderCtrl(bc_loadingGuiCycleTime) 
		 {
			profile = "GuiSliderProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "325 260";
			extent = "174 64";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			range = "5000.000000 20000.000000";
			ticks = "15";
			value = "10000";
			snap = "1";
			variable = "$PREF::BC::LOADINGGUICYCLETIME";
		 };
      };
   };
};

new guiSwatchCtrl(bc_UICornerSwatch)
{
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "69 69";
	minExtent = "8 2";
	enabled = "1";
	visible = "0";
	clipToParent = "1";
	color = "100 100 100 200";
	
	new guiBitmapCtrl(bc_UICornerImage)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "3 3";
		extent = "63 63";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		text = "   ";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "screenshots/parthenon";
		lockAspectRatio = "0";
		alignLeft = "0";
		alignTop = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
		command = "bc_guiFullScreenBitmap();";

		new guiMouseEventCtrl(bc_UICornerImageEvent)
		{
			extent = "66 66";
			position = "0 0";
		};
	};
};

new GuiBitmapButtonCtrl(bc_UINewPicture) 
{
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "32 32";
	minExtent = "8 2";
	enabled = "1";
	visible = "0";
	clipToParent = "1";
	text = "   ";
	groupNum = "-1";
	buttonType = "PushButton";
	bitmap = "add-ons/client_blockcam/images/newpicture_icon";
	command = "";
	lockAspectRatio = "0";
	alignLeft = "0";
	alignTop = "0";
	overflowImage = "0";
	mKeepCached = "0";
	mColor = "255 255 255 255";
};

new guiSwatchCtrl(bc_UISSTypeSwatch)
{
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "180 69";
	minExtent = "8 2";
	enabled = "1";
	visible = "0";
	clipToParent = "1";
	color = "100 100 100 200";
	
	
	 new GuiRadioCtrl(bc_shotTypeDefault) {
		profile = "GuiRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "3 3";
		extent = "80 20";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		text = "Default";
		groupNum = "1";
		buttonType = "RadioButton";
		command = "bc_setScreenShotType(DEFAULT);";
	 };
	 
	 new GuiRadioCtrl(bc_shotTypeDof) {
		profile = "GuiRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "3 23";
		extent = "80 20";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		text = "DOF";
		groupNum = "1";
		buttonType = "RadioButton";
		command = "bc_setScreenShotType(DOF);";
	 };
	 
	 new GuiRadioCtrl(bc_shotTypeIcon) {
		profile = "GuiRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "3 43";
		extent = "80 20";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		text = "Icon";
		groupNum = "1";
		buttonType = "RadioButton";
		command = "bc_setScreenShotType(ICON);";
	 };
	 
	 new GuiRadioCtrl(bc_shotTypeHud) {
		profile = "GuiRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "83 3";
		extent = "80 20";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		text = "HUD";
		groupNum = "1";
		buttonType = "RadioButton";
		command = "bc_setScreenShotType(HUD);";
	 };
	 
	 new GuiRadioCtrl(bc_shotTypePanorama) {
		profile = "GuiRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "83 23";
		extent = "80 20";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		text = "Panorama";
		groupNum = "1";
		buttonType = "RadioButton";
		command = "bc_setScreenShotType(PANORAMA);";
	 };	
};

new GuiMLTextCtrl(bc_loadingGuiWatermark) 
{
	profile = "HUDChatTextEditSize4Profile";
	horizSizing = "center";
	vertSizing = "top";
	position = "0 0";
	extent = "400 25";
	minExtent = "8 2";
	enabled = "1";
	visible = "1";
	clipToParent = "1";
	lineSpacing = "2";
	allowColorChars = "0";
	maxChars = "-1";
	text = "";
	maxBitmapHeight = "-1";
	selectable = "1";
	autoResize = "1";
};

new GuiSwatchCtrl(bc_renameSS) {
 profile = "GuiDefaultProfile";
 horizSizing = "right";
 vertSizing = "bottom";
 position = "50 112";
 extent = "261 61";
 minExtent = "8 2";
 enabled = "1";
 visible = "1";
 clipToParent = "1";
 color = "100 100 100 150";
 command = "canvas.popdialog(bc_renamess);";
 accelerator = "Escape";

 new GuiSwatchCtrl() {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "262 23";
	minExtent = "8 2";
	enabled = "1";
	visible = "1";
	clipToParent = "1";
	color = "80 80 80 150";

	new GuiMLTextCtrl() {
	   profile = "HUDChatTextEditSize4Profile";
	   horizSizing = "center";
	   vertSizing = "top";
	   position = "0 1";
	   extent = "262 20";
	   minExtent = "8 2";
	   enabled = "1";
	   visible = "1";
	   clipToParent = "1";
	   lineSpacing = "2";
	   allowColorChars = "0";
	   maxChars = "-1";
	   text = "<just:center><font:impact:20>Rename Screenshot";
	   maxBitmapHeight = "-1";
	   selectable = "0";
	   autoResize = "1";
	};
 };
 new GuiTextEditCtrl(bc_renameEdit) {
	profile = "GuiTextEditProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "9 30";
	extent = "241 18";
	minExtent = "8 2";
	enabled = "1";
	visible = "1";
	clipToParent = "1";
	maxLength = "255";
	historySize = "0";
	password = "0";
	tabComplete = "0";
	sinkAllKeyEvents = "0";
	command = "";
	accelerator = "return";
	altcommand = "bc_doRename(bc_renameEdit.getValue());bc_renameEdit.setValue(\"\");bc_control.getObject(0).remove(bc_renameSS);";
 };
};

//--- OBJECT WRITE END ---

if(isObject(bc_screenShotContainer))
{
	bc_screenShotContainer.delete();
}

new scriptGroup(bc_screenShotContainer);

function bc_screenShotsToContainer()
{
	setModPaths(getModPaths());
	%INT_FILECOUNT = getFileCount("screenshots/*");
	
	for(%i=0;%i<%INT_FILECOUNT;%i++)
	{
		%STR_FILE = findNextFile("screenshots/*");
		
		if(bc_screenShotContainer.fileRegistered[strReplace(%STR_FILE,fileExt(%STR_FILE),"")])
			continue;
		
		%STR_DATE = getFileModifiedTime(%STR_FILE);
		%STR_NAME = fileBase(%STR_FILE);
		%STR_EXT = fileExt(%STR_FILE);
		
		%OBJ_IMAGEDATA = new scriptObject()
		{
			parent = bc_screenShotContainer;
			path = strReplace(%STR_FILE,%STR_EXT,"");
			date = %STR_DATE;
			name = %STR_NAME;
			extension = %STR_EXT;
		};

		bc_screenShotContainer.fileRegistered[strReplace(%STR_FILE,%STR_EXT,"")] = true;
		bc_screenShotContainer.add(%OBJ_IMAGEDATA);
	}
}

bc_screenShotsToContainer();

function bc_deleteScreenShot(%STR_PATH)
{
	%STR_PATH = strReplace(%STR_PATH,fileExt(%STR_PATH),"");
	%OBJ_IMAGEDATA = bc_screenShotContainer.getObjByPath(%STR_PATH);
	
	if(isObject(%OBJ_IMAGEDATA))
	{
		if(isFile(%STR_PATH @ %OBJ_IMAGEDATA.extension) && bc_screenShotContainer.fileRegistered[%STR_PATH])
		{
			bc_screenShotContainer.fileRegistered[%STR_PATH] = 0;
				
			%del = fileDelete(%STR_PATH @ %OBJ_IMAGEDATA.extension);
			%OBJ_IMAGEDATA.delete();
			schedule(5,0,bc_GUIListCtrlPopulate);
		}
	}
}

function bc_renameScreenShot(%STR_PATH,%STR_NAME)
{
	%BOOL_RESULT = 0;
	if(isFile(%STR_PATH))
	{
		%STR_REALPATH = filePath(%STR_PATH);
		%STR_ORIGEXTENSION = fileExt(%STR_PATH);
		if(%STR_NAME !$= "")
		{
			%STR_NAME = fileBase(%STR_NAME) @ %STR_ORIGEXTENSION;
			//bc_log("trying for " @ %STR_PATH @ " | " @ %STR_REALPATH @ "/" @ %STR_NAME);
			%BOOL_RESULT = fileCopy(%STR_PATH,%STR_REALPATH @ "/" @ %STR_NAME);
			
			if(%BOOL_RESULT)
			{
				//bc_log("trying to delete " @ %str_path);
				bc_deleteScreenshot(%STR_PATH);
				bc_ScreenShotsToContainer();
				bc_GUIListCtrlPopulate();
			}
		}
	}
	
	//BC_LOG("RENAME SCREENSHOT VAL RETURNED " @ %BOOL_rESULT);
	return %BOOL_RESULT;
}

function bc_doRename(%STR_RENAME)
{
	if(%STR_RENAME $= "")
		return 0;
		
	%STR_NAME = bc_sslist.getRowTextById(bc_sslist.getSelectedId());
	%STR_OBJ = bc_screenShotContainer.getObjByName(%STR_NAME);
	
	if(isObject(%STR_OBJ))
	{
		%STR_FULL = %STR_OBJ.path @ %STR_OBJ.extension;
		bc_renameScreenShot(%STR_FULL,%STR_RENAME);
	}
}

function bc_screenShotContainer::getObjByPath(%OBJ_CONTAINER,%STR_PATH)
{
	%INT_COUNT = %OBJ_CONTAINER.getCount();
	
	for(%i=0;%i<%INT_COUNT;%i++)
	{
		%OBJ_IMAGEDATA = %OBJ_CONTAINER.getObject(%i);
		
		if(%OBJ_IMAGEDATA.path $= %STR_PATH)
			return %OBJ_IMAGEDATA;
	}
	
	return false;
}

function bc_screenShotContainer::getObjByName(%OBJ_CONTAINER,%STR_NAME)
{
	%INT_COUNT = %OBJ_CONTAINER.getCount();
	
	for(%i=0;%i<%INT_COUNT;%i++)
	{
		%OBJ_IMAGEDATA = %OBJ_CONTAINER.getObject(%i);
		
		if(%OBJ_IMAGEDATA.name $= %STR_NAME)
			return %OBJ_IMAGEDATA;
	}
	
	return false;
}

$BC::DEFAULTSS["ACMCITY"] = true;
$BC::DEFAULTSS["ARTILLERYATTACK"] = true;
$BC::DEFAULTSS["BLPETROL"] = true;
$BC::DEFAULTSS["GLASSELEVATORS"] = true;
$BC::DEFAULTSS["ICEPALACE"] = true;
$BC::DEFAULTSS["ISLAND"] = true;
$BC::DEFAULTSS["NIGHTTITANIC"] = true;
$BC::DEFAULTSS["PARTHENON"] = true;

function bc_GUIListCtrlPopulate()
{
	bc_SSList.clear();
	
	%OBJ_CONTAINER = bc_screenShotContainer;
	%INT_COUNT = %OBJ_CONTAINER.getCount();
	
	for(%i=0;%i<%INT_COUNT;%i++)
	{
		%OBJ_IMAGEDATA = %OBJ_CONTAINER.getObject(%i);
		%STR_NAME = %OBJ_IMAGEDATA.name;
		
		if($PREF::BC::HIDEDEFAULTSCREENSHOTS && $BC::DEFAULTSS[%STR_NAME])
			continue;
		
		bc_SSList.addRow(%i,%STR_NAME);
	}
}

function bc_ssList::onSelect(%INT_ID, %INT_ROWNUM, %STR_NAME)
{	
	%INT_TIME = getSimTime();

	if($BC::GUILASTSELECTED $= %INT_ROWNUM && %INT_TIME - $BC::GUILASTSELECTEDTIME <= 400)
	{
		messageBoxYesNo("Block Cam Alert","Would you like to rename the selected screenshot?","bc_GUIshowRenameSS();","");
	}
	
	%OBJ_IMAGEDATA = bc_screenShotContainer.getObjByName(%STR_NAME);
	%STR_PATH = %OBJ_IMAGEDATA.path;
	bc_GUISetScreenShot(%STR_PATH);
	
	$BC::GUILASTSELECTED = %INT_ROWNUM;
	$BC::GUILASTSELECTEDTIME = %INT_TIME;
}

function bc_GUIShowRenameSS()
{
	%VECTOR_POS = (getWord(bc_control.getObject(0).extent,0) / 2) - (getWord(bc_renameSS.extent,0) / 2) SPC getWord(bc_control.getObject(0).extent,1) / 2;
	bc_renamess.position = %VECTOR_POS;
	bc_control.getObject(0).add(bc_renamess);
	//bc_log("showing rename ss at " @ %VECTOR_POS);
}

function bc_GUISetScreenShot(%STR_PATH)
{
	if(strStr(%STR_PATH,".") >= 0)
	{
		%STR_PATH = getSubStr(%STR_PATH,0,strStr(%STR_PATH,"."));
	}
	
	bc_screenShotView.setBitmap(%STR_PATH);
}

function bc_GUIFullScreenBitmap()
{
	if(isObject(bc_fullscreen))
		bc_fullscreen.delete();
		
	%GUIOBJ_BITMAP = new guiBitMapCtrl(bc_fullscreen : bc_screenShotView);
	%GUIOBJ_BITMAP.position = "0 0";
	%GUIOBJ_BITMAP.extent = getWords(getRes(),0,1);
	%GUIOBJ_BITMAP.accelerator = "Escape";
	%GUIOBJ_BITMAP.command = "canvas.popDialog(bc_fullscreen);bc_fullScreenText.delete();bc_fullscreen.delete();";
	
	%GUIOBJ_TEXT = new GuiMLTextCtrl(bc_fullscreenText) 
	{
		profile = "HUDChatTextEditSize4Profile";
		horizSizing = "center";
		vertSizing = "top";
		position = "0 0";
		extent = "254 25";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		lineSpacing = "2";
		allowColorChars = "0";
		maxChars = "-1";
		text = "<just:center><font:impact:35>Press Escape To Close";
		maxBitmapHeight = "-1";
		selectable = "1";
		autoResize = "1";
	};
	
	%GUIOBJ_BITMAP.add(%GUIOBJ_TEXT);
	canvas.pushDialog(%GUIOBJ_BITMAP);
}

function bc_control::onWake(%OBJ_GUICTRL)
{
	%OBJ_RADIOCTRL = bc_blockCamShadeQuality @ $PREF::BC::BLOCKCAMSHADEQUALITY;
	%OBJ_RADIOCTRL.setValue(true);
	
	bc_hideDefaultScreenShotCheckBox.setValue($PREF::BC::HIDEDEFAULTSCREENSHOTS);
	
	bc_loadingGuiCheckBox.setValue($PREF::BC::LOADINGGUICUSTOMIMAGE);
	bc_loadingGuiCycleTime.setValue($PREF::BC::LOADINGGUICYCLETIME);
	
	bc_GUIListCtrlPopulate();
	
	moveMap.bind("keyboard","right",bc_GUINextScreenShot);
	moveMap.bind("keyboard","left",bc_GUIPreviousScreenShot);
}

function bc_control::onSleep(%OBJ_GUICTRL)
{
	moveMap.bind("keyboard","right",$BC::RIGHTARROWKEYCOMMAND);
	moveMap.bind("keyboard","left",$BC::LEFTARROWKEYCOMMAND);
}

function bc_UICornerImageEvent::onMouseDown(%OBJ_EVENT,%VECT_MOUSEPOS)
{
	bc_GUISetScreenShot(bc_UICornerImage.bitmap);
	canvas.pushDialog(bc_control);
}

function bc_UIcornerImageEvent::onMouseEnter(%OBJ_EVENT,%VECT_MOUSEPOS)
{
	bc_UIcornerSwatch.oldPosition = bc_UIcornerSwatch.position;
	bc_UIcornerSwatch.position = getWord(bc_UIcornerSwatch.position,0) SPC (getWord(bc_UIcornerSwatch.position,1) - 10);
}

function bc_UIcornerImageEvent::onMouseLeave(%OBJ_EVENT,%VECT_MOUSEPOS)
{
	bc_UIcornerSwatch.position = bc_UIcornerSwatch.oldPosition;
}

function bc_toggleDefaultScreenShotVal()
{
	if($PREF::BC::HIDEDEFAULTSCREENSHOTS)
	{
		$PREF::BC::HIDEDEFAULTSCREENSHOTS = 0;
		bc_GUIListCtrlPopulate();
	}
	else
	{
		$PREF::BC::HIDEDEFAULTSCREENSHOTS = 1;
		bc_GUIListCtrlPopulate();
	}
}

function bc_GUINextScreenShot(%INT_VAL)
{
	if(%INT_VAL $= "" || %INT_VAL $= "1")
	{
		%INT_SELECTED = bc_sslist.getSelectedID();
		
		if(%INT_SELECTED == -1)
		{
			bc_sslist.currentRowSelected = -1;
		}
		
		bc_sslist.currentRowSelected++;
		bc_sslist.setSelectedRow(bc_sslist.currentRowSelected);
		
		if(bc_sslist.currentRowSelected >= bc_sslist.rowCount())
			bc_sslist.currentRowSelected = -1;
			
		%INT_COUNT = canvas.getCount();
			
		for(%i=0;%i<%INT_COUNT;%i++)
		{
			%OBJ_CHILD = canvas.getObject(%i);
			
			if(%OBJ_CHILD.getName() $= "bc_Fullscreen")
			{
				bc_GUIFullScreenBitmap();
				break;
			}
		}
	}
}

function bc_GUIPreviousScreenShot(%INT_VAL)
{
	if(%INT_VAL $= "" || %INT_VAL $= "1")
	{
		%INT_SELECTED = bc_sslist.getSelectedID();
		
		if(%INT_SELECTED == -1)
		{
			bc_sslist.currentRowSelected = 1;
		}
		
		bc_sslist.currentRowSelected--;
		bc_sslist.setSelectedRow(bc_sslist.currentRowSelected);
		
		if(bc_sslist.currentRowSelected <= 0)
			bc_sslist.currentRowSelected = bc_sslist.rowCount();
			
		%INT_COUNT = canvas.getCount();
		
		for(%i=0;%i<%INT_COUNT;%i++)
		{
			%OBJ_CHILD = canvas.getObject(%i);
			
			if(%OBJ_CHILD.getName() $= "bc_Fullscreen")
			{
				bc_GUIFullScreenBitmap();
				break;
			}
		}
	}
}

function bc_initWatermark()
{	
	//don't make fun of me :(
	
	bc_log("Adding Block Cam watermark.");
	
	loadingGui.add(bc_loadingGuiWatermark);
	
	%INT_RES = getWords(loadingGui.extent,0,1);
	%INT_RESX = getWord(%INT_RES,0);
	%INT_RESY = getWord(%INT_RES,1);
	
	%INT_EX = bc_loadingGuiWatermark.extent;
	%INT_EXX = getWord(%INT_EX,0);
	%INT_EXY = getWord(%INT_EX,1);
	
	%INT_MID = (%INT_RESX / 2) - (%INT_EXX / 2);
	
	bc_loadingGuiWatermark.position = %INT_MID SPC (%INT_RESY - %INT_EXY * 2);
	bc_loadingGuiWatermark.setText("<shadow:5:5><shadowcolor:00000066><just:center><font:impact:50>Block Cam <font:impact:30>Version " @ $BC::VERSION);
	bc_loadingGuiWatermark.setVisible(0);
	bc_loadingGuiWatermark.initialized = true;
	//bc_log("Set watermark at " @ bc_loadingGuiWatermark.position @ " res: " @ %INT_rES);
}

bc_initialize();